import java.util.HashMap;
import java.util.Iterator;
import java.util.ArrayList;

public class NodeAliveChecker extends Thread
{
	private static final int PERIODIC_SLEEP_TIME = 10000;
	private static final int ALIVE_CHECK_TIMEOUT = 20000;
	private static final String checkAliveMsg = "AliveEcho";
	private HashMap<Integer, EmulatedNode> emulatedNodes;
	
	NodeAliveChecker(HashMap<Integer, EmulatedNode> emulatedNodes) {
		this.emulatedNodes = emulatedNodes;
	}

	public void run() {
	while (true) {
		Iterator<EmulatedNode> iter;
		ArrayList<EmulatedNode> nodes = new ArrayList<EmulatedNode>();
		synchronized(this.emulatedNodes) {
			iter = this.emulatedNodes.values().iterator();
			while (iter.hasNext()) {
				nodes.add((EmulatedNode)iter.next());
			}
		}

		iter = nodes.iterator();
		while (iter.hasNext()) {
			EmulatedNode node = (EmulatedNode)iter.next();
			if (!node.aliveStatus)
				continue;
			try {
				node.out.println(checkAliveMsg);
				String msg;
				msg = node.in.readLine();
				node.aliveStatus = (msg != null) && (msg.equals(checkAliveMsg));
/*				if (node.aliveStatus == true)
					System.out.println("Node " + node.getFishAddr() + " is still alive");
				else
					System.out.println("Node " + node.getFishAddr() + " is dead");
*/			}
			catch (Exception e) {
				node.aliveStatus = false;
//				System.out.println("Node " + node.getFishAddr() + " is dead");
			}
		}
		try {
			sleep(PERIODIC_SLEEP_TIME);
		}
		catch (Exception e) {
			System.err.println("Exception occurred while nodeAliveChecker was sleeping: " + e);
			System.exit(1);
		}
	}
	}
}
